﻿Imports System.IO
Imports System.IO.Compression
Imports System.Threading.Thread

Public Class Aggiorna_Archivio

    Public WithEvents TCP As New System.Net.WebClient

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If Button1.Text = " ArchivioEstrazioni  Download!" Then
            On Error GoTo Err
            If ComboBox_http.SelectedIndex = 1 Then
                SaveFileDialog1.FileName = "Archivio_estrazioni_Excel_dal1939.csv"
            End If
            SaveFileDialog1.InitialDirectory = "C:\Archivio_Estrazioni_NforLotto"
            DialogResult = SaveFileDialog1.ShowDialog()
            If DialogResult = Windows.Forms.DialogResult.OK Then
                TCP.DownloadFileAsync(New Uri(ComboBox_http.Text), SaveFileDialog1.FileName)
                Button1.Text = "Ferma"
                ComboBox_http.Enabled = False
            End If
        Else
            TCP.CancelAsync()
            ComboBox_http.Enabled = True
            Button1.Text = " ArchivioEstrazioni  Download!"
        End If
        Exit Sub
Err:    MessageBox.Show("Errore! " & ErrorToString(), "Errore!", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub

    Public Mem1 As String, Mem2 As String

    Private Sub PrgChngd(ByVal sender As Object, ByVal e As System.Net.DownloadProgressChangedEventArgs) Handles TCP.DownloadProgressChanged
        ProgressBar1.Value = e.ProgressPercentage
        If e.TotalBytesToReceive > 1073741824 Then
            Mem1 = Math.Round((((e.TotalBytesToReceive / 1024) / 1024) / 1024), 2) & " GB"
        Else
            Mem1 = Math.Round((((e.TotalBytesToReceive / 1024) / 1024)), 2) & " MB"
        End If
        Label3.Text = Mem1

        If e.BytesReceived > 1073741824 Then
            Mem2 = Math.Round((((e.BytesReceived / 1024) / 1024) / 1024), 2) & " GB"
        Else
            Mem2 = Math.Round((((e.BytesReceived / 1024) / 1024)), 2) & " MB"
        End If
        Label4.Text = Mem2
        Label5.Text = e.ProgressPercentage & "%"
    End Sub

    Private Sub PrgComplete(ByVal sender As Object, ByVal e As System.ComponentModel.AsyncCompletedEventArgs) Handles TCP.DownloadFileCompleted
        If e.Cancelled = True Or Me.ProgressBar1.Value = 0 Then
            MessageBox.Show("Errore! Il download non è stato completato!" + vbNewLine + vbNewLine + "Verificare se la Linea di Rete è Connessa, o l'indirizzo immesso sia valido.", "Errore!", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            Threading.Thread.Sleep(1000)
            'Aggiunge l'OpenFileDialog
            Dim Open As New OpenFileDialog
            'Metti il formato
            If ComboBox_http.SelectedIndex = 0 Then
                Open.Filter = " Files Zippato, Archivio_Estrazioni_Lotto_zip|*.*"
                Open.Title = " Devi decomprimere il File.zip    Archivio_Estrazioni_Lotto_zip "
                Open.FileName = "Archivio_Estrazioni_Lotto_zip"
                Open.InitialDirectory = "C:\Archivio_Estrazioni_NforLotto"
                MessageBox.Show("Il Download è stato completato con successo!" + vbNewLine + vbNewLine + "Ora puoi decomprimere L'Archivio zippato." + vbNewLine, "Download Completo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            ElseIf ComboBox_http.SelectedIndex = 1 Then
                Open.Filter = " Files Excel(csv), Archivio_Estrazioni_Lotto|*.*"
                Open.Title = " Devi aprire il File Excel, Archivio_Estrazioni_Lotto_Excel "
                Open.FileName = "Archivio_estrazioni_Excel_dal1939"
                Open.InitialDirectory = "C:\Archivio_Estrazioni_NforLotto"
                MessageBox.Show("Il Download è stato completato con successo!" + vbNewLine + vbNewLine + "Ora puoi aprire l'Archivio Excel." + vbNewLine, "Download Completo", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If
            'Metti che si apre l'OpenFileDialog e apra
            If Open.ShowDialog = Windows.Forms.DialogResult.OK Then
                Dim cartella = "C:\Archivio_Estrazioni_NforLotto"
                System.Diagnostics.Process.Start("explorer.exe", cartella)
                Me.Close()
            Else
                Me.Close()
            End If
        End If
        ComboBox_http.Enabled = True
        Button1.Text = "Download Terminato"
    End Sub

    Private Sub Btn_Carica_Aggiorna_Archivio_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Carica_Aggiorna_Archivio.Click
        Dim indexData As Int32
        If Rdb_1939.Checked = True Then
            indexData = 2
        ElseIf Rdb_1970.Checked = True Then
            indexData = 1619
        ElseIf Rdb_2001.Checked = True Then
            indexData = 3436
        ElseIf Rdb_2009.Checked = True Then
            indexData = 4529
        End If
        Call Modifica_Archivio_Excel(indexData)
        Dim DataString As String = Form1.DataUltEstraz
        Try
            Dim Splitta As String() = DataString.Split(New [Char]() {"/"c})
            If CInt(Splitta(0)) > 31 Then
                DataString = Splitta(2) & "/" & Splitta(1) & "/" & Splitta(0)
            End If
        Catch ex As Exception
            MsgBox(ex.Message & "  Caricare prima l'Archivio estrazioni attuale.", MsgBoxStyle.Information)
            Exit Sub
        End Try
        Call Aggiorna_Archivio_Storico01_Oggi(DataString)

    End Sub

    Private Sub Btn_Defoult_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Defoult.Click
        'ripristina a defoult i parametri.
        ' data estrazione
        NAD_Par1.Value = 1
        ' nome Ruota
        NAD_Par2.Value = 2
        ' primo estratto
        NAD_Par3.Value = 3
        ' secondo estratto
        NAD_Par4.Value = 4
        ' terzo estratto
        NAD_Par5.Value = 5
        ' quarto estratto
        NAD_Par6.Value = 6
        ' quinto estratto
        NAD_Par7.Value = 7

    End Sub

    Friend Sub Immisione_Parametri_csv()
        'Imposta i parametri per la lettura da File Excel (csv).
        ' data estrazione
        NAD_Par1.Value = 1
        ' nome Ruota
        NAD_Par2.Value = 7
        ' primo estratto
        NAD_Par3.Value = 2
        ' secondo estratto
        NAD_Par4.Value = 3
        ' terzo estratto
        NAD_Par5.Value = 4
        ' quarto estratto
        NAD_Par6.Value = 5
        ' quinto estratto
        NAD_Par7.Value = 6
    End Sub

    Private Sub Btn_Excel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Excel.Click

        Call Immisione_Parametri_csv()
    End Sub

    Friend Sub Modifica_Archivio_Excel(ByVal ne As Int32)
        Dim Nuovo_Archivio As New System.Text.StringBuilder
        Dim contaRighe As Int32 = 0
        Try
            Dim leggi As New System.IO.StreamReader("C:\Archivio_Estrazioni_NforLotto\Archivio_estrazioni_Excel_dal1939.csv")
            Dim riga As String
            Dim colonneItems() As String
            Dim data As String = ""
            Do While leggi.Peek <> -1
                riga = leggi.ReadLine()
                colonneItems = Split(riga, ";")
                'DataGridView1.Rows.Add(colonneItems)
                If contaRighe > ne Then
                    For i As Int32 = 0 To colonneItems.Length - 1
                        If i >= colonneItems.Length Then Exit For
                        Select Case i
                            Case 0
                                data = colonneItems(i) & ";"
                                Nuovo_Archivio.Append(data)
                            Case 2, 3, 4, 5
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                            Case 6
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Nuovo_Archivio.Append("BA;")
                                Nuovo_Archivio.AppendLine()
                                Nuovo_Archivio.Append(data)
                            Case 7, 8, 9, 10
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                            Case 11
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Nuovo_Archivio.Append("CA;")
                                Nuovo_Archivio.AppendLine()
                                Nuovo_Archivio.Append(data)
                            Case 12, 13, 14, 15
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                            Case 16
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Nuovo_Archivio.Append("FI;")
                                Nuovo_Archivio.AppendLine()
                                Nuovo_Archivio.Append(data)
                            Case 17, 18, 19, 20
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                            Case 21
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Nuovo_Archivio.Append("GE;")
                                Nuovo_Archivio.AppendLine()
                                Nuovo_Archivio.Append(data)
                            Case 22, 23, 24, 25
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                            Case 26
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Nuovo_Archivio.Append("MI;")
                                Nuovo_Archivio.AppendLine()
                                Nuovo_Archivio.Append(data)
                            Case 27, 28, 29, 30
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                            Case 31
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Nuovo_Archivio.Append("NA;")
                                Nuovo_Archivio.AppendLine()
                                Nuovo_Archivio.Append(data)
                            Case 32, 33, 34, 35
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                            Case 36
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Nuovo_Archivio.Append("PA;")
                                Nuovo_Archivio.AppendLine()
                                Nuovo_Archivio.Append(data)
                            Case 37, 38, 39, 40
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                            Case 41
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Nuovo_Archivio.Append("RM;")
                                Nuovo_Archivio.AppendLine()
                                Nuovo_Archivio.Append(data)
                            Case 42, 43, 44, 45
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                            Case 46
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Nuovo_Archivio.Append("TO;")
                                Nuovo_Archivio.AppendLine()
                                Nuovo_Archivio.Append(data)
                            Case 47, 48, 49, 50
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                            Case 51
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Nuovo_Archivio.Append("VE;")
                                Nuovo_Archivio.AppendLine()
                                Nuovo_Archivio.Append(data)
                            Case 52, 53, 54, 55
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                            Case 56
                                Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Nuovo_Archivio.Append("RN;")
                        End Select
                    Next i
                    Nuovo_Archivio.AppendLine()
                End If
                contaRighe += 1
            Loop
            leggi.Close()
            leggi.Dispose()
            'salviamo su File il nuovo Archivio
            Dim FileName As String = "C:\Archivio_Estrazioni_NforLotto\Archivio_estrazioni_excel_programma.csv"
            Using w As New IO.StreamWriter(FileName, False)

                w.Write(Nuovo_Archivio)
                w.Close()
                w.Dispose()
                MsgBox(" Nuovo Archivio Excel salvato. ", MsgBoxStyle.Information)
            End Using
        Catch ex As Exception
            MsgBox("Riga:" & contaRighe & " " & ex.Message, MsgBoxStyle.Information)
        End Try

    End Sub

    Friend Sub Aggiorna_Archivio_Storico01_Oggi(ByVal Ultima As String)
        Dim Nuovo_Archivio As New System.Text.StringBuilder
        Dim contaRighe As Int32 = 0
        Dim NewEstr As Int32 = 0
        Dim Ok As Boolean = False
        Dim data As String
        Dim Splittadata As String()
        Try
            Dim leggi As New System.IO.StreamReader("C:\Archivio_Estrazioni_NforLotto\Archivio_estrazioni_Excel_dal1939.csv")
            Dim riga As String
            Dim colonneItems() As String
            Do While leggi.Peek <> -1
                riga = leggi.ReadLine()
                colonneItems = Split(riga, ";")
                'DataGridView1.Rows.Add(colonneItems)
                If contaRighe > 2000 Then
                    For i As Int32 = 0 To colonneItems.Length - 1
                        If i >= colonneItems.Length Then Exit For
                        If Ok = True AndAlso Not colonneItems(0) = "" Then
                            Select Case i
                                Case 0
                                    data = colonneItems(i)
                                    Splittadata = data.Split(New [Char]() {"/"c})
                                    data = Splittadata(2) & "/" & Splittadata(1) & "/" & Splittadata(0) & ";"
                                    Nuovo_Archivio.Append(data)
                                Case 2
                                    Nuovo_Archivio.Append("BA;")
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 3, 4, 5, 6
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 7
                                    Nuovo_Archivio.AppendLine()
                                    Nuovo_Archivio.Append(data)
                                    Nuovo_Archivio.Append("CA;")
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 8, 9, 10, 11
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 12
                                    Nuovo_Archivio.AppendLine()
                                    Nuovo_Archivio.Append(data)
                                    Nuovo_Archivio.Append("FI;")
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 13, 14, 15, 16
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 17
                                    Nuovo_Archivio.AppendLine()
                                    Nuovo_Archivio.Append(data)
                                    Nuovo_Archivio.Append("GE;")
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 18, 19, 20, 21
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 22
                                    Nuovo_Archivio.AppendLine()
                                    Nuovo_Archivio.Append(data)
                                    Nuovo_Archivio.Append("MI;")
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 23, 24, 25, 26
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 27
                                    Nuovo_Archivio.AppendLine()
                                    Nuovo_Archivio.Append(data)
                                    Nuovo_Archivio.Append("NA;")
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 28, 29, 30, 31
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 32
                                    Nuovo_Archivio.AppendLine()
                                    Nuovo_Archivio.Append(data)
                                    Nuovo_Archivio.Append("PA;")
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 33, 34, 35, 36
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 37
                                    Nuovo_Archivio.AppendLine()
                                    Nuovo_Archivio.Append(data)
                                    Nuovo_Archivio.Append("RM;")
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 38, 39, 40, 41
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 42
                                    Nuovo_Archivio.AppendLine()
                                    Nuovo_Archivio.Append(data)
                                    Nuovo_Archivio.Append("TO;")
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 43, 44, 45, 46
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 47
                                    Nuovo_Archivio.AppendLine()
                                    Nuovo_Archivio.Append(data)
                                    Nuovo_Archivio.Append("VE;")
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 48, 49, 50, 51
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 52
                                    Nuovo_Archivio.AppendLine()
                                    Nuovo_Archivio.Append(data)
                                    Nuovo_Archivio.Append("RN;")
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 53, 54, 55
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                Case 56
                                    Nuovo_Archivio.Append(colonneItems(i) & ";")
                                    Nuovo_Archivio.AppendLine()
                            End Select
                        End If
                    Next i
                    If Ok = True AndAlso Not colonneItems(0) = "" Then
                        NewEstr += 1
                    End If
                End If
                If Ultima = colonneItems(0) Then Ok = True
                contaRighe += 1
            Loop
            leggi.Close()
            leggi.Dispose()
            If NewEstr = 0 Then
                MsgBox(" Non ci sono estrazioni da aggiornare, scaricare l'Archivio excel(csv) e riprovare. ", MsgBoxStyle.Information)
                Exit Sub
            Else
                MsgBox(Nuovo_Archivio.ToString, MsgBoxStyle.Information)
            End If
            'salviamo su File il nuovo Archivio
            Dim Str2data As String = data.Trim.Replace("/", "-")
            Str2data = Str2data.Replace(";", "")
            Dim Str1data As String = Form1.TextBoxDataEstrazione.Text.Trim.Replace("/", "-")
            Dim FileName As String = "C:\Archivio_Estrazioni_NforLotto\storico01-oggi-" & Str1data.Trim & ".txt"
            Using w As New IO.StreamWriter(FileName, True)
                w.Write(Nuovo_Archivio)
                w.Close()
                w.Dispose()
                MsgBox(" Archivio storico01 aggiornato. Estrazioni aggiunte: " & NewEstr & " ,Riavviare il programma. ", MsgBoxStyle.Information)
            End Using
            My.Computer.FileSystem.RenameFile("storico01-oggi" & "-" & Str1data.Trim & ".txt", "storico01-oggi" & "-" & Str2data.Trim & ".txt")
            Form1.NomeArchivio = "storico01-oggi" & "-" & Str2data.Trim & ".txt"
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information)
        End Try

    End Sub

    Private Sub Aggiorna_Archivio_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        'Nascondo il form.
        e.Cancel = True
        Me.Hide()
    End Sub

End Class