﻿

Imports System.Threading
Imports System.Drawing.Drawing2D

Public Class FormSelezionaNumeri


    ' Dichiarazioni globali.    ----------------------------------------------------------------------

    Dim VettNsclelti(0 To 89) As Integer
    Dim Num As Integer = 0
    Dim Conta As Integer


    '-------------------------------------------------------------------------------------------------


    Private Sub FormSelezionaNumeri_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If Form_Archivio.LstEvidenziaN.Count > 0 Then

            CaricaDati(Form_Archivio.LstEvidenziaN)

        End If

    End Sub

    Private Sub FrmSelezNumeri_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint

        Dim colore1 As Color = Color.LimeGreen
        Dim colore2 As Color = Color.OrangeRed
        Dim gradient_brush As New LinearGradientBrush(New Point(0, 0), New Point(Me.Width, 0), colore1, colore2)

        e.Graphics.FillRectangle(gradient_brush, 0, 0, Me.Width, Me.Height)

    End Sub

    Public Sub CaricaDati(ByRef ListaN As List(Of Int16))

        For Each TxtBtnValue As Control In Me.Panel1.Controls

            If (CInt(TxtBtnValue.TabIndex + 1) < 91) And (ListaN.Contains(CInt(TxtBtnValue.TabIndex + 1)) = True) Then
                TxtBtnValue.BackColor = Form_Archivio.Colori(CInt(TxtBtnValue.TabIndex + 1))           'Color.DarkOrange
            Else
                TxtBtnValue.BackColor = Color.White
            End If

        Next TxtBtnValue

        Me.TextBoxTotNum.Text = ListaN.Count
        Me.ButtonInserisci.Enabled = False

    End Sub

    Public Sub CaricaVettori()

        If Conta < 91 Then

            For j As Int32 = 0 To 89 Step +1

                If VettNsclelti(j) = Num Then

                    VettNsclelti(j) = 0
                    Conta -= 1
                    j = 0
                    Me.TextBoxTotNum.Text = Conta
                    Form_Archivio.Colori(Num) = Color.White
                    Exit Sub
                End If

            Next j


            For i As Int32 = 0 To Conta Step +1

                If VettNsclelti(i) = 0 Then
                    VettNsclelti(i) = Num
                    Conta += 1
                    Me.TextBoxTotNum.Text = Conta
                    Exit For
                End If

            Next i


        End If

    End Sub

    Private Sub BtnGruppo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn90.Click, Btn9.Click, Btn89.Click, Btn88.Click, Btn87.Click, Btn86.Click, Btn85.Click, Btn84.Click, Btn83.Click, Btn82.Click, Btn81.Click, Btn80.Click, Btn8.Click, Btn79.Click, Btn78.Click, Btn77.Click, Btn76.Click, Btn75.Click, Btn74.Click, Btn73.Click, Btn72.Click, Btn71.Click, Btn70.Click, Btn7.Click, Btn69.Click, Btn68.Click, Btn67.Click, Btn66.Click, Btn65.Click, Btn64.Click, Btn63.Click, Btn62.Click, Btn61.Click, Btn60.Click, Btn6.Click, Btn59.Click, Btn58.Click, Btn57.Click, Btn56.Click, Btn55.Click, Btn54.Click, Btn53.Click, Btn52.Click, Btn51.Click, Btn50.Click, Btn5.Click, Btn49.Click, Btn48.Click, Btn47.Click, Btn46.Click, Btn45.Click, Btn44.Click, Btn43.Click, Btn42.Click, Btn41.Click, Btn40.Click, Btn4.Click, Btn39.Click, Btn38.Click, Btn37.Click, Btn36.Click, Btn35.Click, Btn34.Click, Btn33.Click, Btn32.Click, Btn31.Click, Btn30.Click, Btn3.Click, Btn29.Click, Btn28.Click, Btn27.Click, Btn26.Click, Btn25.Click, Btn24.Click, Btn23.Click, Btn22.Click, Btn21.Click, Btn20.Click, Btn2.Click, Btn19.Click, Btn18.Click, Btn17.Click, Btn16.Click, Btn15.Click, Btn14.Click, Btn13.Click, Btn12.Click, Btn11.Click, Btn10.Click, Btn1.Click

        ' Questo metodo consente di gestire tutti i Button quando vi si clicca sopra.
        ' Ogni Button cliccato verrà identificato dal metodo sender.
        Dim clickedButton As Button = TryCast(sender, Button)
        'variabile che memorizza l'indexTab
        Num = clickedButton.TabIndex + 1


        If Not clickedButton.BackColor = Color.White Then

            clickedButton.BackColor = Color.White
        Else
            clickedButton.BackColor = Me.BtnColori.BackColor
            Form_Archivio.Colori(clickedButton.TabIndex + 1) = Me.BtnColori.BackColor
        End If
        Application.DoEvents()
        CaricaVettori()

    End Sub

    Private Sub BtnReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnReset.Click

        Num = 0
        Conta = 0
        For i As Int32 = 0 To VettNsclelti.Length - 1
            Me.VettNsclelti(i) = Nothing
        Next i

        For Each contrBtn As Control In Me.Panel1.Controls

            If Not contrBtn.BackColor = Color.White Then
                contrBtn.BackColor = Color.White
            End If
        Next contrBtn

        Me.ListBoxNum.Items.Clear()
        Form_Archivio.LstEvidenziaN.Clear()
        FuncResetColorEvidenzia()
        ButtonInserisci.Enabled = True
    End Sub

    Private Sub ButtonInserisci_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonInserisci.Click

        If Conta > 0 Then
            For i As Int32 = 0 To Conta - 1 Step +1
                Me.ListBoxNum.Items.Add(VettNsclelti(i))
                Form_Archivio.LstEvidenziaN.Add(VettNsclelti(i))
            Next i

            ButtonInserisci.Enabled = False
        End If

    End Sub

    Private Sub BtnColori_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnColori.Click
        ' Scegli il colore per evidenziare i numeri.

        If ColorDialogX.ShowDialog = Windows.Forms.DialogResult.OK Then

            Me.BtnColori.BackColor = ColorDialogX.Color

        End If
    End Sub

    Private Sub LblColor5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LblColor7.Click, LblColor6.Click, LblColor5.Click, LblColor4.Click, LblColor3.Click, LblColor2.Click

        Dim colore As Color
        ' Ogni Label cliccato verrà identificato dal metodo sender.
        Dim clickedLabel As Label = TryCast(sender, Label)
        colore = clickedLabel.BackColor
        BtnColori.BackColor = colore

    End Sub

End Class