﻿

Imports System.IO
Imports System.Threading
Imports System.Threading.Tasks
Imports System.Text.StringBuilder
Imports System.Windows

Public Class Form_Archivio

    ' Zona globale  -----------------------------------------------------
    Dim AnnoTxt As String
    Dim MeseTxt As String
    Dim GiornoTxt As String
    Public LstEvidenziaN As New List(Of Int16)
    Friend Colori As New Dictionary(Of Int16, Color)
    Dim ColorBase As Color
    '--------------------------------------------------------------------

   
   

    Private Sub Form_Archivio_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' Inizializzo i colori di evidenziazione.
        FuncIniColorEvidenzia()
        Me.RichTextBoxIncolla.Visible = False
        Carica_Archivio_Estrazioni2("")
        Me.TimerOrario.Start()

    End Sub

    'Funzione che esegue la lettura e il caricamento dell'Archivio estrazioni in formato testo.
    Public Sub Carica_Archivio_Estrazioni2(ByVal Ruota As String)

        'Se la lista Archivio è vuota
        If Form1.LstArchivio.Count < 1 And Form1.Consenso3 = False Then
            'Aggiungi l'OpenFileDialog
            Dim Open As New OpenFileDialog
            'metti il formato
            Open.Filter = " Files di Testo, storico01-oggi|*.txt|File excel|*.csv"
            Open.Title = " Devi aprire il File.txt   ---->>>  storico01-oggi...... "
            Open.InitialDirectory = "C:\Archivio_Estrazioni_NforLotto"
            'Metti che si apre l'OpenFileDialog e apra
            If Open.ShowDialog = Windows.Forms.DialogResult.OK Then
                If Open.FilterIndex = 2 Then Call Aggiorna_Archivio.Immisione_Parametri_csv()
                Application.DoEvents()
                Dim lettura As New IO.StreamReader(Open.FileName)
                'Cancello ListaArchivio
                Form1.LstArchivio.Clear()
                'Una stringa che rappresenta ogni singola riga del file
                Dim Riga As String
                ' Variabile contatore
                Dim Conta As Int32 = -1
                'Imposta il testo della label di stato
                Form1.LabelAvvisi.Text = "Apertura del file in corso..."
                'Fa rispettare l'ordine delle istruzioni
                Application.DoEvents()
                'Attende 1 secondi
                Thread.Sleep(1000)
                'Fa rispettare l'ordine delle istruzioni
                Application.DoEvents()
                'Finchè non si raggiunge la fine del file si continua
                'a leggere
                While Not lettura.EndOfStream
                    'Leggiamo una linea di file (S)
                    Riga = lettura.ReadLine
                    'Se la linea è diversa da una riga vuota....
                    If (Riga Is Nothing) Or (Riga = "") Or (Riga.Length < 10) Then
                        'Se la riga è vuota la salta.
                        'MsgBox("La Riga è nothing " & Riga.Length & "  Form1.RuoteArchivio.count=" & Form1.RuoteArchivio.Count)
                    Else
                        ' Incremento Conta
                        Conta += 1
                        Dim Carattere As String = ""
                        Dim NuovaRiga As String = ""
                        Dim ContaColonne As Int16 = 0
                        Dim NCA As Int16 = 0
                        'Con un ciclo For Each verifico tutti i caratteri della stringa Riga
                        For Each c As Char In Riga
                            If c = "	"c Or c = "	"c Or c = "_" Or c = ";" Then
                                ContaColonne += 1
                            End If
                            Carattere = CStr(c)
                            If Carattere = " " Then
                                ContaColonne += 1
                            End If
                            If c = "	"c Or c = "	"c Or c = "_" Or c = ";" Or Carattere = " " Then
                                'Carico le Liste_Colonne dei dati
                                Select Case ContaColonne
                                    Case Is = Aggiorna_Archivio.NAD_Par1.Value
                                        Form1.DataArchivio.Add(NuovaRiga)
                                        NCA += 1
                                    Case Is = Aggiorna_Archivio.NAD_Par2.Value
                                        Form1.RuoteArchivio.Add(NuovaRiga)
                                        NCA += 1
                                    Case Is = Aggiorna_Archivio.NAD_Par3.Value
                                        Form1.PrimoEstr.Add(NuovaRiga)
                                        NCA += 1
                                    Case Is = Aggiorna_Archivio.NAD_Par4.Value
                                        Form1.SecondoEstr.Add(NuovaRiga)
                                        NCA += 1
                                    Case Is = Aggiorna_Archivio.NAD_Par5.Value
                                        Form1.TerzoEstr.Add(NuovaRiga)
                                        NCA += 1
                                    Case Is = Aggiorna_Archivio.NAD_Par6.Value
                                        Form1.QuartoEstr.Add(NuovaRiga)
                                        NCA += 1
                                    Case Is = Aggiorna_Archivio.NAD_Par7.Value
                                        Form1.QuintoEstr.Add(NuovaRiga)
                                        NCA += 1
                                End Select
                                'Cancella la stringa
                                NuovaRiga = ""
                            Else
                                'Forma la nuova stringa
                                NuovaRiga += Carattere
                            End If
                            'Ci interessano solo sette Dati della stringa Riga 
                            If NCA = 7 Then
                                Exit For
                            End If
                        Next c
                        'Carico la ListaArchivio
                        Form1.LstArchivio.Add(Riga)
                    End If
                End While
                'Chiude il file
                lettura.Close()
                lettura.Dispose()
                Application.DoEvents()
                Form1.LabelAvvisi.Text = "File aperto, righe combinazioni lette = " & Conta + 1
                Form1.TextBoxDataEstrazione.Text = Form1.DataArchivio(Conta)
                Me.LabelUEA.Text = " Ultima Estr. in Archivio del  " + Form1.DataArchivio(Conta)
                Me.LabelNEA.Text = " Numero Estr. in Archivio:   " & Conta + 1
                Me.TSSLabelStato.Text = "Stato: Archivio Estrazioni caricato. Data ultima estrazione inserita = " & Form1.DataArchivio(Conta)
                Form1.NumEstrazArch = Conta + 1
                Form1.DataUltEstraz = Form1.DataArchivio(Conta)
                Dim Str2data As String = Form1.TextBoxDataEstrazione.Text.Trim.Replace("/", "-")
                Try
                    Form1.NomeArchivio = Open.FileName
                    If Open.FileName = ("C:\Archivio_Estrazioni_NforLotto\storico01-oggi.txt") Then
                        My.Computer.FileSystem.RenameFile("storico01-oggi.txt", "storico01-oggi" & "-" & Str2data & ".txt")
                        Form1.NomeArchivio = "storico01-oggi" & "-" & Str2data & ".txt"
                    End If
                Catch ex As Exception
                    MsgBox(ex.Message)
                End Try
                Application.DoEvents()
                Thread.Sleep(1000)
                ' Visualizzo L'ultima Estrazione in Archivio
                Inserisci_UltimaEstrazione(Form1.DataUltEstraz, Form1.NumEstrazArch)
            End If
            'Se la Lista Archivio è già caricata
        ElseIf (Form1.Consenso3 = False) And (Form1.LstArchivio.Count > 0) Then
            ' Visualizzo L'ultima Estrazione in Archivio
            Inserisci_UltimaEstrazione(Form1.DataUltEstraz, Form1.NumEstrazArch)
            Me.LabelUEA.Text = " Ultima Estr. in Archivio del  " + Form1.DataUltEstraz
            Me.LabelNEA.Text = " Numero Estr. in Archivio:   " & Form1.NumEstrazArch
            Me.TSSLabelStato.Text = "Stato: Archivio Estrazioni caricato. Data ultima estrazione inserita = " & Form1.DataUltEstraz
        End If

    End Sub

    Public Sub Azzera_InterfacciaInsN()

        For Each TxtArch As Control In Me.TableLayoutPanel2.Controls

            TxtArch.Text = ""

        Next TxtArch

    End Sub

    Public Sub Inserisci_UltimaEstrazione(ByVal Data As String, ByVal NumEA As Int32)

        Dim DataString As String = Data
        Dim Splitta As String() = DataString.Split(New [Char]() {"/"c})
        Try
            NumUpDownAnno.Value = Splitta(0)
            NumUpDownMese.Value = Splitta(1)
            NumUpDownGiorno.Value = Splitta(2)
            AnnoTxt = Splitta(0)
            MeseTxt = Splitta(1)
            GiornoTxt = Splitta(2)
        Catch ex As Exception
            NumUpDownAnno.Value = Splitta(2)
            NumUpDownMese.Value = Splitta(1)
            NumUpDownGiorno.Value = Splitta(0)
            AnnoTxt = Splitta(2)
            MeseTxt = Splitta(1)
            GiornoTxt = Splitta(0)
        End Try
        Dim Conta As Int32 = 0

        For Each DataE As String In Form1.DataArchivio

            If DataE = Data Then

                Select Case Form1.RuoteArchivio(Conta)

                    Case "BA"
                        ImmettiEstratti("BA", Conta)
                    Case "CA"
                        ImmettiEstratti("CA", Conta)
                    Case "FI"
                        ImmettiEstratti("FI", Conta)
                    Case "GE"
                        ImmettiEstratti("GE", Conta)
                    Case "MI"
                        ImmettiEstratti("MI", Conta)
                    Case "NA"
                        ImmettiEstratti("NA", Conta)
                    Case "PA"
                        ImmettiEstratti("PA", Conta)
                    Case "RM"
                        ImmettiEstratti("RM", Conta)
                    Case "TO"
                        ImmettiEstratti("TO", Conta)
                    Case "VE"
                        ImmettiEstratti("VE", Conta)
                    Case "RN"
                        ImmettiEstratti("RN", Conta)
                End Select

            End If
            Conta += 1
        Next DataE

        Application.DoEvents()
        ' Evidenzia i numeri selezionati
        EvidenziaNumeri()

    End Sub

    Public Sub ImmettiEstratti(ByVal Ruota As String, ByVal NumEA As Int32)

        Dim Cont As Int16 = 0
        Select Case Ruota
            Case "BA"
                Cont = 5
            Case "CA"
                Cont = 10
            Case "FI"
                Cont = 15
            Case "GE"
                Cont = 20
            Case "MI"
                Cont = 25
            Case "NA"
                Cont = 30
            Case "PA"
                Cont = 35
            Case "RM"
                Cont = 40
            Case "TO"
                Cont = 45
            Case "VE"
                Cont = 50
            Case "RN"
                Cont = 55
        End Select
        Dim c5 As Int16 = 1
        For Each ter As Control In Me.TableLayoutPanel2.Controls

            If ter.TabIndex = Cont Then

                Select Case c5
                    Case 1
                        ter.Text = Form1.QuintoEstr(NumEA)
                        c5 += 1
                    Case 2
                        ter.Text = Form1.QuartoEstr(NumEA)
                        c5 += 1
                    Case 3
                        ter.Text = Form1.TerzoEstr(NumEA)
                        c5 += 1
                    Case 4
                        ter.Text = Form1.SecondoEstr(NumEA)
                        c5 += 1
                    Case 5
                        ter.Text = Form1.PrimoEstr(NumEA)
                        Exit For
                End Select

                Cont -= 1
            End If

        Next ter


    End Sub

    Private Sub BtnNewEstraz_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnNewEstraz.Click

        For Each TxtArch As Control In Me.TableLayoutPanel2.Controls

            TxtArch.Text = ""

        Next TxtArch

        Me.ButtonConferma.Enabled = True
        Me.ButtonAnnulla.Enabled = True
        Me.BtnAvantidi10.Enabled = False
        Me.BtnIndietrodi10.Enabled = False
        Me.ButtonIndietro.Enabled = False
        Me.ButtonAvanti.Enabled = False
        Me.BtnNewEstraz.Enabled = False
        Me.BtnIncollaEstrazioni.Visible = True
        NumUpDownAnno.Value = 2014
        NumUpDownMese.Value = 1
        NumUpDownGiorno.Value = 1
        Me.TextBox1.Focus()

    End Sub


    Private Sub ButtonConferma_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonConferma.Click

        Dim Domanda = MsgBox(" Sei sicuro di voler Confermare ?", MsgBoxStyle.YesNo, "Salva nuova Estrazione")
        If Domanda = MsgBoxResult.Yes Then

            Me.BtnNewEstraz.Enabled = False
            Me.ButtonAnnulla.Enabled = False
            Application.DoEvents()
            Dim Str1data As String = Form1.TextBoxDataEstrazione.Text.Trim.Replace("/", "-")
            Dim DataString As String = Form1.DataUltEstraz
            Dim Splitta As String() = DataString.Split(New [Char]() {"/"c})
            Dim A As Int32
            Dim M As Int16
            Dim G As Int16
            If Aggiorna_Archivio.NAD_Par2.Value = 7 Then
                A = CInt(Splitta(2))
                M = CInt(Splitta(1))
                G = CInt(Splitta(0))
            Else
                A = CInt(Splitta(0))
                M = CInt(Splitta(1))
                G = CInt(Splitta(2))
            End If
            Dim A2 As Int32 = NumUpDownAnno.Value
            Dim M2 As Int16 = NumUpDownMese.Value
            Dim G2 As Int16 = NumUpDownGiorno.Value
            Dim dA As Int16 = A - A2
            Dim dM As Int16 = M - M2
            Dim dg As Int16 = G - G2
            'Verifico la data.
            If (dA > 0) Or (dA = 0 And dM > 0) Or (dA = 0 And dM = 0 And dg > 0) Or (dA = 0 And dM = 0 And dg = 0) Then
                MsgBox(" La Data che hai inserito non è valida ", MsgBoxStyle.Information)
                Exit Sub
            End If

            For Each TNArch As Control In Me.TableLayoutPanel2.Controls

                Try

                    Dim ValueN As Int16 = CInt(TNArch.Text)

                    If ValueN < 1 Or ValueN > 90 Then
                        MsgBox(" Numero non valido, deve essere da 1 a 90 ", MsgBoxStyle.Information)
                        TNArch.Focus()
                        Exit Sub
                    End If

                Catch

                    MsgBox(" Numero non valido, inserisci numero ", MsgBoxStyle.Information)
                    TNArch.Focus()
                    Exit Sub
                End Try


            Next TNArch

            Dim MatrixRuote(11, 5) As Int16
            Dim cont As Int16 = 0

            For r As Int16 = 1 To 11 Step +1

                For c As Int16 = 1 To 5 Step +1
                    cont += 1
                    For Each TNArch As Control In Me.TableLayoutPanel2.Controls

                        If TNArch.TabIndex = cont Then
                            MatrixRuote(r, c) = TNArch.Text
                        End If

                    Next TNArch

                Next c

                For d As Int16 = 1 To 4 Step +1

                    For k As Int16 = (d + 1) To 5 Step +1
                        'Verifico i numeri.
                        If MatrixRuote(r, d) = MatrixRuote(r, k) Then
                            Dim Ruota As String = ""
                            Select Case r
                                Case 1
                                    Ruota = "Bari"
                                Case 2
                                    Ruota = "Cagliari"
                                Case 3
                                    Ruota = "Firenze"
                                Case 4
                                    Ruota = "Genova"
                                Case 5
                                    Ruota = "Milano"
                                Case 6
                                    Ruota = "Napoli"
                                Case 7
                                    Ruota = "Palermo"
                                Case 8
                                    Ruota = "Roma"
                                Case 9
                                    Ruota = "Torino"
                                Case 10
                                    Ruota = "Venezia"
                                Case 11
                                    Ruota = "Nazionale"
                            End Select
                            MsgBox(" Attenzione c'e un numero ripetuto sulla Ruota di " & Ruota, MsgBoxStyle.Information)
                            Exit Sub
                        End If

                    Next k

                Next d

            Next r

            ' Avvio il salvataggio dell'etrazione inserita manualmente.
            Dim Anno As String = CStr(NumUpDownAnno.Value)
            Dim Mese As String
            If NumUpDownMese.Value < 10 Then
                Mese = "0" & CStr(NumUpDownMese.Value)
            Else
                Mese = CStr(NumUpDownMese.Value)
            End If
            Dim Giorno As String
            If NumUpDownGiorno.Value < 10 Then
                Giorno = "0" & CStr(NumUpDownGiorno.Value)
            Else
                Giorno = CStr(NumUpDownGiorno.Value)
            End If

            Dim NuovaEstrazione As New System.Text.StringBuilder

            For r As Int16 = 1 To 11 Step +1
                NuovaEstrazione.Append(Anno & "/" & Mese & "/" & Giorno & "_")
                Select Case r
                    Case 1
                        NuovaEstrazione.Append("BA_")
                    Case 2
                        NuovaEstrazione.Append("CA_")
                    Case 3
                        NuovaEstrazione.Append("FI_")
                    Case 4
                        NuovaEstrazione.Append("GE_")
                    Case 5
                        NuovaEstrazione.Append("MI_")
                    Case 6
                        NuovaEstrazione.Append("NA_")
                    Case 7
                        NuovaEstrazione.Append("PA_")
                    Case 8
                        NuovaEstrazione.Append("RM_")
                    Case 9
                        NuovaEstrazione.Append("TO_")
                    Case 10
                        NuovaEstrazione.Append("VE_")
                    Case 11
                        NuovaEstrazione.Append("RN_")
                End Select

                For c As Int16 = 1 To 5 Step +1

                    NuovaEstrazione.Append(CStr(MatrixRuote(r, c)) & "_")
                Next c

                NuovaEstrazione.AppendLine()
            Next r

            Try
                'Apre SaveFileDialog
                Dim Open As New SaveFileDialog
                'metti il formato
                Open.Filter = " Files di Testo, storico01-oggi|*.txt"
                Open.Title = "Salva estrazione in File.txt   ---->>>  storico01-oggi...... "
                Open.InitialDirectory = "C:\Archivio_Estrazioni_NforLotto"
                Open.FileName = Form1.NomeArchivio
                'Metti che si apre l'OpenFileDialog e apra
                If Open.ShowDialog = Windows.Forms.DialogResult.OK Then

                    Using w As New IO.StreamWriter(Open.FileName, True)

                        w.Write(NuovaEstrazione)
                        w.Close()
                        w.Dispose()
                        MsgBox(" Nuova Estrazione Salvata ", MsgBoxStyle.Information)
                    End Using
                End If
            Catch ex As Exception

                MsgBox(" File Archivio: " & ex.Message, MsgBoxStyle.Information)
            End Try

            'Inserimento in Liste Archivio.
            Dim NuovaE As String = ""
            Dim ArrayRuote() As String = {"BA", "CA", "FI", "GE", "MI", "NA", "PA", "RM", "TO", "VE", "RN"}

            For r As Int16 = 1 To 11 Step +1

                NuovaE = (Anno & "/" & Mese & "/" & Giorno)
                Form1.DataArchivio.Add(NuovaE)
                NuovaE = NuovaE & "  " & ArrayRuote(r - 1) & "            "
                Form1.RuoteArchivio.Add(ArrayRuote(r - 1))

                For c As Int16 = 1 To 5 Step +1

                    NuovaE = NuovaE & (CStr(MatrixRuote(r, c)) & "            ")
                    'Carico le Liste_Colonne dei dati
                    Select Case c
                        Case 1
                            Form1.PrimoEstr.Add(CStr(MatrixRuote(r, c)))
                        Case 2
                            Form1.SecondoEstr.Add(CStr(MatrixRuote(r, c)))
                        Case 3
                            Form1.TerzoEstr.Add(CStr(MatrixRuote(r, c)))
                        Case 4
                            Form1.QuartoEstr.Add(CStr(MatrixRuote(r, c)))
                        Case 5
                            Form1.QuintoEstr.Add(CStr(MatrixRuote(r, c)))
                    End Select
                Next c
                'Carico la ListaArchivio
                Form1.LstArchivio.Add(NuovaE)
                NuovaE = ""
            Next r

            Dim NEinList As Int32 = Form1.DataArchivio.Count
            Form1.DataUltEstraz = Form1.DataArchivio(NEinList - 1)
            Form1.NumEstrazArch = NEinList
            Me.LabelUEA.Text = " Ultima Estr. in Archivio del  " + Form1.DataUltEstraz
            Me.LabelNEA.Text = " Numero Estr. in Archivio   " & Form1.NumEstrazArch
            Form1.TextBoxDataEstrazione.Text = Form1.DataArchivio(NEinList - 1).ToString
            Dim Str2data As String = Form1.TextBoxDataEstrazione.Text.Trim.Replace("/", "-")
            Try
                My.Computer.FileSystem.RenameFile("storico01-oggi" & "-" & Str1data.Trim & ".txt", "storico01-oggi" & "-" & Str2data.Trim & ".txt")
                Form1.NomeArchivio = "storico01-oggi" & "-" & Str2data.Trim & ".txt"
            Catch ex As Exception
                MsgBox(ex.Message & " é stato selezionato un archivio non previsto.")
            End Try
            Me.ButtonIndietro.Enabled = True
            Me.ButtonAvanti.Enabled = True
            Me.BtnIndietrodi10.Enabled = True
            Me.BtnAvantidi10.Enabled = True
            Me.BtnNewEstraz.Enabled = True
            Me.ButtonConferma.Enabled = False
            Call CambiaStatoBtnSalva()
        ElseIf Domanda = MsgBoxResult.No Then

            Me.ButtonAnnulla.Enabled = True
            Exit Sub
        End If

    End Sub

    Private Sub ButtonAnnulla_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAnnulla.Click

        Call Azzera_InterfacciaInsN()
        Me.ButtonIndietro.Enabled = True
        Me.ButtonAvanti.Enabled = True
        Me.BtnIndietrodi10.Enabled = True
        Me.BtnAvantidi10.Enabled = True
        Me.ButtonConferma.Enabled = False
        Me.BtnNewEstraz.Enabled = True
        Me.BtnIncollaEstrazioni.Visible = False
        If ButtonConferma.Text.Trim = "SALVA" Then Call CambiaStatoBtnSalva()
        Call Carica_Archivio_Estrazioni2("")

    End Sub

    Private Sub ButtonIndietro_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonIndietro.Click


        Dim EstrazData As String
        If Aggiorna_Archivio.NAD_Par2.Value = 7 Then
            EstrazData = (GiornoTxt + "/" + MeseTxt + "/" + AnnoTxt)
        Else
            EstrazData = (AnnoTxt + "/" + MeseTxt + "/" + GiornoTxt)
        End If

        Dim IndxData As Int32 = 0

        For i As Int32 = Form1.DataArchivio.Count - 1 To 1 Step -1

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then
                IndxData = i
                Exit For
            End If

        Next i

        If IndxData = 0 Then
            Exit Sub
        End If

        For i As Int32 = IndxData To 1 Step -1

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then

            Else
                IndxData = i
                Dim cn As Int32 = CInt(LblConta.Text)
                LblConta.Text = cn - 1
                Exit For
            End If

        Next i

        Inserisci_UltimaEstrazione(Form1.DataArchivio.Item(IndxData), IndxData)

    End Sub

    Private Sub ButtonAvanti_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAvanti.Click

        Dim EstrazData As String
        If Aggiorna_Archivio.NAD_Par2.Value = 7 Then
            EstrazData = (GiornoTxt + "/" + MeseTxt + "/" + AnnoTxt)
        Else
            EstrazData = (AnnoTxt + "/" + MeseTxt + "/" + GiornoTxt)
        End If

        Dim IndxData As Int32 = 0

        For i As Int32 = Form1.DataArchivio.Count - 1 To 1 Step -1

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then
                IndxData = i
                Exit For
            End If

        Next i

        If IndxData = 0 Then
            Exit Sub
        End If

        For i As Int32 = IndxData To Form1.DataArchivio.Count - 1 Step +1

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then

            Else
                IndxData = i
                Dim cn As Int32 = CInt(LblConta.Text)
                LblConta.Text = cn + 1
                Exit For
            End If

        Next i

        Inserisci_UltimaEstrazione(Form1.DataArchivio.Item(IndxData), IndxData)

    End Sub


    Private Sub TimerOrario_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerOrario.Tick

        Me.LabelOrario.Text = My.Computer.Clock.LocalTime.ToLongTimeString

    End Sub

    Private Sub BtnOpBrowser_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnOpBrowser.Click

        Try
            'Questa linea di codice serve per aprire un link di Internet nel browser predefinito del sistema in uso.
            System.Diagnostics.Process.Start("http://www.lottomaticaitalia.it/lotto/risultatieconcorsi/estrazioni_ultime.html")
        Catch ex As Exception
            MsgBox(" Non sei collegato alla Rete Internet !" & ex.Message, MsgBoxStyle.Information)
        End Try

    End Sub

    Private Sub BtnEvidenziaN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEvidenziaN.Click

        FormSelezionaNumeri.Show()
    End Sub

    Public Sub EvidenziaNumeri()
        ' Evidenzia i numeri selezionati.

        For Each TxtValue As Control In Me.TableLayoutPanel2.Controls
            If TxtValue.Text = "" Then Exit Sub
            If (CInt(TxtValue.Text) > 0) And (LstEvidenziaN.Contains(CInt(TxtValue.Text)) = True) Then
                TxtValue.BackColor = Colori(CInt(TxtValue.Text))
            Else
                TxtValue.BackColor = Color.White
            End If

        Next TxtValue

    End Sub

    Public Sub EvidenziaNumeriRipetuti()
        ' Evidenzia i numeri Ripetuti.
        For Each TxtValue1 As Control In Me.TableLayoutPanel2.Controls
            If TxtValue1.Text = "" Then Exit Sub
            If TxtValue1.BackColor = Color.YellowGreen Then
                Continue For
            End If
            For Each TxtValue2 As Control In Me.TableLayoutPanel2.Controls
                If TxtValue1.TabIndex = TxtValue2.TabIndex Then
                    Continue For
                End If
                If (CInt(TxtValue2.Text) > 0) AndAlso (CInt(TxtValue2.Text) = (CInt(TxtValue1.Text))) Then
                    If TxtValue1.BackColor = Color.Yellow Then
                        TxtValue1.BackColor = Color.Red
                        TxtValue2.BackColor = Color.Red
                        Colori(CInt(TxtValue2.Text)) = Color.Red
                    End If
                    If TxtValue1.BackColor = Color.YellowGreen Then
                        TxtValue1.BackColor = Color.Yellow
                        TxtValue2.BackColor = Color.Yellow
                        Colori(CInt(TxtValue2.Text)) = Color.Yellow
                    Else
                        TxtValue1.BackColor = Color.YellowGreen
                        TxtValue2.BackColor = Color.YellowGreen
                    End If

                    If Not LstEvidenziaN.Contains((CInt(TxtValue1.Text))) Then
                        LstEvidenziaN.Add((CInt(TxtValue1.Text)))
                        Colori(CInt(TxtValue1.Text)) = Color.DarkOrange
                    End If
                End If
            Next TxtValue2
        Next TxtValue1

    End Sub

    Private Sub BtnIndietrodi10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnIndietrodi10.Click

        Dim EstrazData As String
        If Aggiorna_Archivio.NAD_Par2.Value = 7 Then
            EstrazData = (GiornoTxt + "/" + MeseTxt + "/" + AnnoTxt)
        Else
            EstrazData = (AnnoTxt + "/" + MeseTxt + "/" + GiornoTxt)
        End If
        Dim IndxData As Int32 = 0

        For i As Int32 = Form1.DataArchivio.Count - 1 To 1 Step -1

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then
                IndxData = i
                Exit For
            End If

        Next i

        If IndxData = 0 Then
            Exit Sub
        End If

        For i As Int32 = (IndxData) To 1 Step -110

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then

            Else
                IndxData = i
                Dim cn As Int32 = CInt(LblConta.Text)
                LblConta.Text = cn - 10
                Exit For
            End If

        Next i


        Inserisci_UltimaEstrazione(Form1.DataArchivio.Item(IndxData), IndxData)

    End Sub

    Private Sub BtnAvantidi10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAvantidi10.Click

        Dim EstrazData As String
        If Aggiorna_Archivio.NAD_Par2.Value = 7 Then
            EstrazData = (GiornoTxt + "/" + MeseTxt + "/" + AnnoTxt)
        Else
            EstrazData = (AnnoTxt + "/" + MeseTxt + "/" + GiornoTxt)
        End If

        Dim IndxData As Int32 = 0

        For i As Int32 = Form1.DataArchivio.Count - 1 To 1 Step -1

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then
                IndxData = i
                Exit For
            End If

        Next i

        If IndxData = 0 Then
            Exit Sub
        End If

        For i As Int32 = (IndxData) To Form1.DataArchivio.Count - 1 Step +110

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then

            Else
                IndxData = i
                Dim cn As Int32 = CInt(LblConta.Text)
                LblConta.Text = cn + 10
                Exit For
            End If

        Next i


        Inserisci_UltimaEstrazione(Form1.DataArchivio.Item(IndxData), IndxData)

    End Sub

    Private Sub LblConta_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LblConta.Click
        'Azzera il contatore.
        LblConta.Text = 0
    End Sub

    Private Sub BtnIncollaEstrazioni_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnIncollaEstrazioni.Click
        Call CambiaColoreRTB()
        Me.MonthCalendar1.SendToBack()
        Me.RichTextBoxIncolla.BringToFront()
        Me.RichTextBoxIncolla.Visible = True
        Call RTBCeI()

    End Sub

    Friend Sub RTBCeI()

        If BtnIncollaEstrazioni.Text.Trim = "Copia e  Incolla  le Estrazioni" Then
            Me.BtnIncollaEstrazioni.Text = "Confermi le estrazioni ?"
            Me.RichTextBoxIncolla.Text = "Incolla quì le Estrazioni di tutte le Ruote contemporaneamente, con o senza i nomi delle Ruote, non inserire Date o altri numeri" & Environment.NewLine & "Cliccare il pulsante destro del Mouse..." & Environment.NewLine
        Else
            Call Conferma_Estrazione()
            Me.BtnIncollaEstrazioni.Text = "Copia e  Incolla  le Estrazioni"
            Me.BtnIncollaEstrazioni.Visible = False
            Me.RichTextBoxIncolla.SendToBack()
            Me.RichTextBoxIncolla.Visible = False
            Me.RichTextBoxIncolla.Clear()
            Me.BtnIncollaEstrazioni.ForeColor = Color.Blue
            Call CambiaStatoBtnSalva()
        End If

    End Sub
    Friend Sub CambiaStatoBtnSalva()

        If ButtonConferma.Text.Trim = "Conferma" Then
            ButtonConferma.Text = "SALVA"
            ButtonConferma.BackColor = Color.Coral
        Else
            ButtonConferma.Text = "Conferma"
            ButtonConferma.BackColor = Color.LightBlue
        End If

    End Sub

    Private Sub CancellaToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancellaToolStripMenuItem.Click

        Me.RichTextBoxIncolla.Clear()
    End Sub

    Private Sub ConfermaToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConfermaToolStripMenuItem.Click
        Call CambiaColoreRTB()
        Call CambiaStatoBtnSalva()
        Call Conferma_Estrazione()
        Me.BtnIncollaEstrazioni.Text = "Copia e  Incolla  le Estrazioni"
        Me.BtnIncollaEstrazioni.Visible = False
        Me.RichTextBoxIncolla.SendToBack()
        Me.RichTextBoxIncolla.Visible = False
        Me.RichTextBoxIncolla.Clear()
        Me.BtnIncollaEstrazioni.ForeColor = Color.Blue
    End Sub

    Private Sub UndoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UndoToolStripMenuItem.Click

        Me.RichTextBoxIncolla.Undo()
    End Sub

    Private Sub SelectedAllToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SelectedAllToolStripMenuItem.Click

        Me.RichTextBoxIncolla.SelectAll()
    End Sub

    Private Sub CopyToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyToolStripMenuItem.Click

        Me.RichTextBoxIncolla.Copy()
    End Sub

    Private Sub IncollaToolStripMenuItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles IncollaToolStripMenuItem.Click

        Me.RichTextBoxIncolla.Text = ""
        Me.RichTextBoxIncolla.Font = New Font("Comic Sans MS", 10, FontStyle.Bold)
        Me.RichTextBoxIncolla.Paste()
        Me.RichTextBoxIncolla.AppendText(" Per inserire i Dati devi Confermare, premere il pulsante destro del Mouse." & Environment.NewLine _
                                         & " Terminato di caricare tutte le Estrazioni e averle prima Salvate, spegnere e Riavviare il Programma. ")
        Me.BtnIncollaEstrazioni.ForeColor = Color.Chocolate
    End Sub

    Private Sub TagliaToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TagliaToolStripMenuItem.Click
        Me.RichTextBoxIncolla.Cut()
    End Sub

    Private Sub AccodaTestoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AccodaTestoToolStripMenuItem.Click

        Me.RichTextBoxIncolla.Paste()
    End Sub

    Friend Sub Conferma_Estrazione()

        Dim StrEstraz As String = RichTextBoxIncolla.Text
        Dim StrNow As String = ""
        Dim Cont As Int32 = 0
        For Each c As Char In StrEstraz
            If Not IsNumeric(c) Then
                If Cont = 1 Or Cont = 2 Then
                    StrNow &= ";"
                    Cont = 0
                End If
            Else
                StrNow &= (c)
                Cont += 1
            End If
        Next c
        Dim SplittaRTB As String() = StrNow.Split(New [Char]() {" "c, ";"c, "."c})
        Dim LstRtb As New List(Of String)
        For Each Str As String In SplittaRTB

            If Not IsNumeric(Str) Then
                Continue For
            End If
            LstRtb.Add(Str)
        Next Str

        For Each estrX As Control In Me.TableLayoutPanel2.Controls

            Try

                If estrX.Text.Trim = "" Then
                    estrX.Text = LstRtb.Item(index:=estrX.TabIndex - 1)
                End If

            Catch ex As Exception

                Dim msg As String
                msg = " Numero non valido, Formato non valido,  Errore "
                MsgBox(msg, MsgBoxStyle.Information)
                Me.ButtonConferma.Enabled = False
                estrX.Focus()
                Exit Sub
            End Try

        Next estrX

    End Sub

    Friend Sub CambiaColoreRTB()
        If Me.RichTextBoxIncolla.BackColor = Color.Yellow Then
            Me.RichTextBoxIncolla.BackColor = Color.DarkTurquoise
        Else
            Me.RichTextBoxIncolla.BackColor = Color.Yellow
        End If
    End Sub

    Private Sub BtnEvRipetuti_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEvRipetuti.Click
        'Avvio procedura che evidenzia i numeri ripetuti
        Call EvidenziaNumeriRipetuti()
    End Sub

    Private Sub BtnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClear.Click
        'Ripristino i colori delle caselle numeriche.
        LstEvidenziaN.Clear()
        Call EvidenziaNumeri()
    End Sub

End Class