﻿Module ModuloFunzioni_e_Procedure

    Friend Sub FunSpecialeStatistica(ByRef Num90Stat() As Int64)

        Dim a As Double
        Dim b As Double
        Dim c As Double
        Dim d As Double
        Dim e As Double
        'Dim f As Double

        For i As Int32 = 0 To 89 Step +1

            a = Num90Stat(i) / 1000
            b = Form1.ArrayIndiceFrequenze90n(i)
            c = (Form1.funIndiceConvenienza(i) / 1.3)
            d = Form1.Frequenza90Numeri90cicli(i)
            e = Form1.Frequenza90NumeriUlt2cicli(i) + 1

            a *= ((b * c * d) / 10) / 1000

            Num90Stat(i) = a

        Next i

    End Sub

    Friend Function RitornaPercentuale(ByVal Perc As Int32) As Int32
        'Funzione che restituisce un valore percentuale.
        Dim x As Int32 = 1000
        Dim Rp As Int32

        Rp = CInt((Perc * x) / 100)

        Return Rp

    End Function


    Friend Function RitornamiStringa(ByVal meStr As String, Optional ByVal leng As Int32 = 0) As String
        Dim l2
        If meStr.Length < leng Then
            l2 = meStr.Length
        Else
            l2 = leng
        End If
        'Mi restituisce una parte della stringa.
        Return meStr.Substring(0, l2)
    End Function

   
    Friend Sub Disabilita(ByVal NChiam As String, Optional ByVal NChiam2 As String = "")
        If Form1.BtnPro.Text.Trim <> NChiam Then
            Form1.BtnPro.Enabled = False
        End If
        Form1.BtnAvvioCG.Enabled = False
        Form1.BtnAmbiTutte.Enabled = False
        If Not NChiam2.Trim = "Non_me" Then Form1.BtnLeMigliori.Enabled = False
        Form1.BtnSimula.Enabled = False
        Form1.BtnMetodoX.Enabled = False
        Form1.BtnCancellaRTB.Enabled = False
        Form1.Btn7e.Enabled = False
    End Sub

    Friend Sub Abilita(ByVal NChiam As String, Optional ByVal NChiam2 As String = "")
        If Form1.BtnPro.Text.Trim <> NChiam Then
            Form1.BtnPro.Enabled = True
        End If
        Form1.BtnAvvioCG.Enabled = True
        Form1.BtnAmbiTutte.Enabled = True
        Form1.BtnLeMigliori.Enabled = True
        Form1.BtnSimula.Enabled = True
        Form1.BtnMetodoX.Enabled = True
        Form1.BtnCancellaRTB.Enabled = True
        Form1.Btn7e.Enabled = True
    End Sub

    Friend Sub DBindietro()

        Dim EstrazData As String
        EstrazData = (Form1.TextBoxDataEstrazione.Text)
        Dim IndxData As Int32 = 0

        For i As Int32 = Form1.DataArchivio.Count - 1 To 1 Step -1

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then
                IndxData = i
                Exit For
            End If

        Next i

        If IndxData = 0 Then
            Exit Sub
        End If

        For i As Int32 = IndxData To 1 Step -1

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then

            Else
                IndxData = i
                Exit For
            End If

        Next i

        Form1.InserisciData(IndxData)
    End Sub

    Friend Sub DBavanti()

        Dim EstrazData As String
        EstrazData = (Form1.TextBoxDataEstrazione.Text)
        Dim IndxData As Int32 = 0

        For i As Int32 = Form1.DataArchivio.Count - 1 To 1 Step -1

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then
                IndxData = i
                Exit For
            End If

        Next i

        If IndxData = 0 Then
            Exit Sub
        End If

        For i As Int32 = IndxData To Form1.DataArchivio.Count - 1 Step +1

            If EstrazData = Form1.DataArchivio.Item(index:=i) Then

            Else
                IndxData = i
                Exit For
            End If

        Next i

        Form1.InserisciData(IndxData)
    End Sub

    Friend Function StatisticheNscelti(ByVal Ruota As String, ByVal DataEstraz As String, Optional ByVal vRuota() As Int32 = Nothing) As List(Of Int32)

        Dim ListaStNScel As New List(Of Int32)
        Dim Med1 As Double = 0.0
        Dim Lev1 As Double = 0.0
        'Avvio la funzione della statistica sulle Frequenze estrazionali.
        Form1.StatFrequenze(Ruota, DataEstraz)
        'Avvio la funzione della statistica sui Ritardi estrazionali.
        Form1.StatRitardi(Ruota, DataEstraz)
        'Avvio la funzione della statistica sui numeri spia.
        If vRuota Is Nothing Then
            Form1.StatNumeriSpia(Form1.VettComb3, Ruota, DataEstraz)
        Else
            Form1.StatNumeriSpia(vRuota, Ruota, DataEstraz)
        End If
        'Avvio la funzione della statistica sulla frequenza ultimi 100 cicli.
        Form1.FunStatFreq90n100C(Ruota, DataEstraz)
        'Avvio la funzione della statistica sulla frequenza ultimi 2 cicli.
        Form1.FunStatFreq90nUlt2C(Ruota, DataEstraz)
        'Avvio funzione IndiceFrequenze 90 numeri.
        Form1.IndiceFrequenza90n(Form1.EstrazioniContate)
        'Rilevo l'indice di convenienza medio.
        For k As Int32 = 1 To 90 Step +1
            Med1 += Form1.funIndiceConvenienza(k - 1)
        Next k
        Med1 /= 90
        Lev1 = Med1 + (Med1 / 2)

        ' Inserisco nella lista i numeri significativi della statistica.
        For i As Int32 = 1 To 90 Step +1
            'Inserisco i dati in una Lista.

            If (Form1.Ritardi90Numeri(i - 1) >= 23 And Form1.ArrayIndiceFrequenze90n(i - 1) >= 1.21) Or (Form1.ArrayIndiceFrequenze90n(i - 1) > 1.75) Then
                If ListaStNScel.Contains(i) = False Then
                    ListaStNScel.Add(i)
                End If
            End If
            If (Form1.ArrayIndiceFrequenze90n(i - 1) >= 1.29 And Form1.Frequenza90Numeri(i - 1) > 0) Then
                If ListaStNScel.Contains(i) = False Then
                    ListaStNScel.Add(i)
                End If
            End If
            If (Form1.ArrayIndiceFrequenze90n(i - 1) > 1.47 And Form1.Frequenza90Numeri(i - 1) = 0 And Form1.Ritardi90Numeri(i - 1) >= 12) Then
                If ListaStNScel.Contains(i) = False Then
                    ListaStNScel.Add(i)
                End If
            End If
            If (Form1.ArrayIndiceFrequenze90n(i - 1) > 1.1 And Form1.Frequenza90Numeri(i - 1) = 0 And Form1.Ritardi90Numeri(i - 1) >= 30) Then
                If ListaStNScel.Contains(i) = False Then
                    ListaStNScel.Add(i)
                End If
            End If
            If Form1.ArrayIndiceFrequenze90n(i - 1) < 0 Or Form1.Ritardi90Numeri(i - 1) >= 40 Then
                If ListaStNScel.Contains(i) = False Then
                    ListaStNScel.Add(i)
                End If
            End If
            If Form1.funIndiceConvenienza(i - 1) >= Lev1 And (ListaStNScel.Contains(i) = False) Then
                'Se l'indice di convenienza è alto.
                ListaStNScel.Add(i)
            End If
            If Form1.Frequenza90NumeriUlt2cicli(i - 1) > 3 Then
                If ListaStNScel.Contains(i) = False Then
                    ListaStNScel.Add(i)
                End If
            End If
        Next i
        Return ListaStNScel
    End Function

    Public Sub ContaRisultati2(ByVal Mtd As String, ByVal Ruota As String, ByVal Data As String, ByVal Ncount As Int32, ByVal lstMetodoX As List(Of Int32), Optional ByVal Tutte As Boolean = True)


        Dim NomeRuota As String = Form1.RitornaNomeRuota(Ruota)
        Dim NQEstr As Int16 = CInt(Form1.NupdowEstr.Value)
        Dim V_estraz(0 To 4) As Int16
        Dim ContaIndex As Int32 = -1
        Dim ContaR As Int32 = -1
        Dim cont As Int32 = 0
        Dim Metodo As String = Mtd
        Dim Ruote() As String = {}
        If Tutte = True Then
            Ruote = {"BA", "CA", "FI", "GE", "MI", "NA", "PA", "RM", "TO", "VE", "RN"}
        Else
            Ruote = {Ruota}
        End If
        Appunti.Show()
        Appunti.TextBoxNotes.Text += vbNewLine + vbNewLine
        Appunti.TextBoxNotes.Text += "                                Elenco risultati " & Metodo & ",  conteggio dei punti realizzati. "
        Appunti.TextBoxNotes.Text += vbNewLine
        Appunti.TextBoxNotes.Text += "                                ------------------------------------------------------------------------------------"
        Appunti.TextBoxNotes.Text += vbNewLine + vbNewLine + vbNewLine
        Appunti.TextBoxNotes.Text += "           Dalla Ruota di - " & NomeRuota & " - e dalla data del - " & Data & "  by Ultimo. "
        Appunti.TextBoxNotes.Text += vbNewLine + vbNewLine + vbNewLine
        Appunti.TextBoxNotes.Text += "         Numeri selezionati da verificare = " & Ncount & "   per  " & NQEstr & "  estrazioni consecutive. "
        Appunti.TextBoxNotes.Text += vbNewLine + vbNewLine
        Appunti.TextBoxNotes.ForeColor = Color.Blue
        For Each RuotaX As String In Ruote
            ContaIndex = -1
            ContaR = -1
            For Each d As String In Form1.DataArchivio
                If d <> Data And ContaR = -1 Then
                    Continue For
                End If
                For Each r As String In Form1.RuoteArchivio
                    ContaIndex += 1
                    If r = RuotaX And Data = Form1.DataArchivio.Item(ContaIndex) Then
                        ContaR += 1
                    ElseIf r = RuotaX And ContaR >= 0 Then
                        ContaR += 1
                    End If
                    If ContaR > 0 And r = RuotaX Then
                        V_estraz(0) = CInt(Form1.PrimoEstr.Item(ContaIndex))
                        V_estraz(1) = CInt(Form1.SecondoEstr.Item(ContaIndex))
                        V_estraz(2) = CInt(Form1.TerzoEstr.Item(ContaIndex))
                        V_estraz(3) = CInt(Form1.QuartoEstr.Item(ContaIndex))
                        V_estraz(4) = CInt(Form1.QuintoEstr.Item(ContaIndex))
                        'Inizio della verifica dei risultati ottenuti e visualizzazione.

                        Dim NumUscitiS As String = ""  ' Numeri usciti.
                        Dim QtaNuscitiS As Int16 = 0
                        For i As Int16 = 0 To 4 Step +1

                            For k As Int16 = 0 To (Ncount - 1) Step +1
                                If V_estraz(i) = lstMetodoX.Item(k) Then

                                    QtaNuscitiS += 1
                                    NumUscitiS += " " & V_estraz(i)
                                End If
                            Next k

                        Next i
                        If QtaNuscitiS > 1 Then
                            Appunti.TextBoxNotes.Text += vbNewLine
                            Appunti.TextBoxNotes.Text += " Esito della  " & ContaR & "^ estrazione, del " & Form1.DataArchivio.Item(ContaIndex) & ",  numeri usciti = " & QtaNuscitiS & "  ( " & NumUscitiS & " )"
                            Appunti.TextBoxNotes.Text += vbNewLine
                            Appunti.TextBoxNotes.Text += "   " & ContaR & ") Numeri e Ruota dell'estrazione: (" & r & " " & V_estraz(0) & " " & V_estraz(1) & " " & V_estraz(2) & " " & V_estraz(3) & " " & V_estraz(4) & ")"
                            Appunti.TextBoxNotes.Text += vbNewLine
                            cont += 1
                        End If
                    End If
                    If (ContaR = NQEstr) Or (ContaIndex = Form1.RuoteArchivio.Count - 1) Then
                        Exit For
                    End If
                Next r
                If (ContaR = NQEstr) Or (ContaIndex = Form1.RuoteArchivio.Count - 1) Then
                    Exit For
                End If
            Next d

        Next RuotaX
        If cont = 0 Then
            Appunti.TextBoxNotes.Text += vbNewLine + vbNewLine
            Appunti.TextBoxNotes.Text += "  Non ci sono stati risultati utili, o non ci sono estrazioni successive... "
            Appunti.TextBoxNotes.Text += vbNewLine
        End If

    End Sub

    Friend Sub FuncIniColorEvidenzia()
        Try
            ' Inizializzo i colori di evidenziazione.
            For i As Int16 = 1 To 90 Step +1
                Form_Archivio.Colori.Add(i, Color.White)
            Next i
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information)
        End Try
    End Sub

    Friend Sub FuncResetColorEvidenzia()
        ' Resetto i colori di evidenziazione.
        For i As Int16 = 1 To 90 Step +1
            Form_Archivio.Colori(i) = Color.White
        Next i
    End Sub

    Friend Sub ImmettiNumeroT(ByVal Ruota As String, ByVal nT As Int32)

        Select Case Ruota
            Case "BA"
                Form1.LblBa.Text = nT
            Case "CA"
                Form1.LblCa.Text = nT
            Case "FI"
                Form1.LblFi.Text = nT
            Case "GE"
                Form1.LblGe.Text = nT
            Case "MI"
                Form1.LblMi.Text = nT
            Case "NA"
                Form1.LblNa.Text = nT
            Case "PA"
                Form1.LblPa.Text = nT
            Case "RM"
                Form1.LblRm.Text = nT
            Case "TO"
                Form1.LblTo.Text = nT
            Case "VE"
                Form1.LblVn.Text = nT
            Case "RN"
                Form1.LblNz.Text = nT
        End Select

    End Sub

    Friend Function funReturnArray(ByVal Ruotabase2 As String, ByVal DtaEstra2 As String, ByVal NumProgr As Int32) As Integer()

        Dim V_estraz(0 To 4) As Int32
        Dim flagOk As Boolean = False
        For i As Int32 = NumProgr To 0 Step -1

            For j As Int32 = i To 0 Step -1

                If (Form1.DataArchivio.Item(index:=i) = DtaEstra2) AndAlso (Form1.RuoteArchivio.Item(index:=j) = Ruotabase2) Then
                    V_estraz(0) = CInt(Form1.PrimoEstr.Item(index:=j))
                    V_estraz(1) = CInt(Form1.SecondoEstr.Item(index:=j))
                    V_estraz(2) = CInt(Form1.TerzoEstr.Item(index:=j))
                    V_estraz(3) = CInt(Form1.QuartoEstr.Item(index:=j))
                    V_estraz(4) = CInt(Form1.QuintoEstr.Item(index:=j))
                    flagOk = True
                    Exit For
                End If
            Next j  'Ruote
            If flagOk = True Then Exit For
        Next i   'Data

        Return V_estraz
    End Function

    Friend Function funReturnArray2(ByVal Ruotabase2 As String, ByVal DtaEstra2 As String, ByVal NumProgrM As Int32) As Integer()

        Dim newdata As String = ""
        For k As Int32 = NumProgrM To 0 Step -1
            If Not Form1.DataArchivio.Item(index:=k) = DtaEstra2 Then
                newdata = Form1.DataArchivio.Item(index:=k)
                Exit For
            End If
        Next k
        Dim V_estraz2(0 To 4) As Int32
        Dim flagOk As Boolean = False
        For i As Int32 = NumProgrM To 0 Step -1

            For j As Int32 = i To 0 Step -1
                If (Form1.DataArchivio.Item(index:=i) = newdata) AndAlso (Form1.RuoteArchivio.Item(index:=j) = Ruotabase2) Then
                    V_estraz2(0) = CInt(Form1.PrimoEstr.Item(index:=j))
                    V_estraz2(1) = CInt(Form1.SecondoEstr.Item(index:=j))
                    V_estraz2(2) = CInt(Form1.TerzoEstr.Item(index:=j))
                    V_estraz2(3) = CInt(Form1.QuartoEstr.Item(index:=j))
                    V_estraz2(4) = CInt(Form1.QuintoEstr.Item(index:=j))
                    flagOk = True
                    Exit For
                End If
            Next j  'Ruote
            If flagOk = True Then Exit For
        Next i   'Data

        Return V_estraz2
    End Function

#Region "################## Funzioni in Background per la Simulazione ########################"
    'Background2---------------------------------------------------------------------------------------


    '--------------------------------------------------------------------------------------------------
#End Region

End Module
